<template>
	<view class="default-box-padding bg-fff border-r-24 u-m-t-32" v-if="data.length">
		<view class=" font-bold u-p-b-32 border-bottom u-m-b-24" v-if="orderInfo.tableName">
			<text class="">桌号：</text>
			<text class="">{{orderInfo.tableName||""}}</text>
		</view>
		<view class="  color-999 border-bottom u-p-b-24">
			<text>共</text>
			<text class="color-333 "> {{goodsNumber}}</text>
			<text>份菜品</text>
		</view>
		<view class="u-m-b-20 " v-for="(order,orderIndex) in data" :key="orderIndex">
			<view class="u-p-t-24"> 第{{ order.placeNum }}次下单
			</view>
			<view class="u-m-t-24 list">
				<view class="item  u-m-b-32" v-for="(item,index) in order.info" :key="index">
					<view class="u-flex u-col-top">
						<view class="u-flex">
							<image class="img" :src="item.coverImg||item.productImg" mode=""></image>
						</view>
						<view class="u-p-l-32 u-flex-1">
							<view class="u-flex u-row-between u-col-top">

								<view class="">
									<view class="u-flex">
										<view class="tui" v-if="isTui(item)">
											{{item.status=='refunding'?'退款中':'已退'}}
										</view>
										<view
											:class="{'line-th':item.status=='return'||item.status=='refund'||item.status=='refunding'}">
											{{item.name||item.productName}}
										</view>
									</view>
									<view class="u-flex u-m-t-8">
										<view class="u-m-r-20 u-flex " v-if="item.gift">
											<uni-tag text="赠送"
												custom-style="background-color: #FFF0DF; border-color: #FFF0DF; color: #FF9F2E;">
											</uni-tag>
										</view>
										<view class="u-m-r-20 u-flex " v-if="item.userCouponId">
											<uni-tag text="商品券抵扣"
												custom-style="background-color: #FFF0DF; border-color: #FFF0DF; color: #FF9F2E;">
											</uni-tag>
										</view>
										<view class="u-m-r-20 u-flex" v-if="item.pack">
											<uni-tag
												custom-style="background-color: #E6F0FF; border-color: #E6F0FF; color: #318AFE;"
												size="small" text="打包" inverted type="success" />
										</view>
									</view>
									<view class="color-999 u-font-24 u-m-t-8">{{item.productSkuName||''}}</view>


									<view class="u-m-t-12 color-666 u-font-24" v-if="item.note">
										备注：{{item.note}}
									</view>
								</view>
								<view class="u-text-right u-m-t-28">
									<template v-if="isTui(item)">
										<view>￥0.00</view>
										<view class="line-th color-666 ">￥{{returnTotalMoney(item)}}
										</view>
									</template>
									<template v-else-if="isGift(item)||item.userCouponId">
										<view>￥0.00</view>
										<view class="line-th color-666 ">￥{{returnTotalMoney(item)}}
										</view>
									</template>
									<template v-else>
										<template v-if="user.isVip&&item.isMember&&returnVipMoney(item)>0&&returnVipMoney(item)!=returnTotalMoney(item)">
											<view>￥{{returnVipMoney(item)}}</view>
											<view class=" color-666 line-th">
												￥{{returnTotalMoney(item)}}</view>
										</template>
										<template v-else>
											<view>￥{{returnTotalMoney(item)}}</view>
										</template>
									</template>
									<view class="u-m-t-22 color-999 u-font-24">X{{item.number||item.num}}</view>
								</view>
							</view>
						</view>
					</view>
					<template v-if="canTuicai(orderInfo,item)">
						<view class="u-flex u-row-right gap-20 u-m-t-24">
							<!-- <my-button :height="60" color="#333" plain type="cancel" shape="circle">更多操作</my-button> -->
							<my-button :width="128" :height="48" plain shape="circle" @tap="tuicai(item,index)"><text
									class="no-wrap">退菜</text></my-button>
						</view>
					</template>
					<template v-if="canTuiKuan(orderInfo,item)">
						<view class="u-flex u-row-right gap-20 u-m-t-20">
							<my-button :width="128" :height="48" plain shape="circle" @tap="tuikuan(item,index)"><text
									class="no-wrap">退款</text> </my-button>
						</view>
					</template>

				</view>
			</view>
			<!-- <view class="bg-gray u-p-20 u-m-t-20" v-if="orderInfo.remark">
				<view>备注</view>
				<view class="u-m-t-10">{{orderInfo.remark}}</view>
			</view> -->
		</view>

		<view class="u-m-t-32">
			<view class="u-flex u-row-between border-top  u-p-t-32">
				<view>
					<template v-if="orderInfo.status=='unpaid'">
						<view class="tag no-pay">
							未支付
						</view>
					</template>
					<template v-if="orderInfo.status=='refund'">
						<view class="tag refund">
							退款成功
						</view>
					</template>
				</view>

				<view class="u-flex">
					<view class="u-flex u-m-r-24" v-if="youhuiAllPrice>0">
						<view class="color-red u-m-r-6 " >
							已优惠￥{{youhuiAllPrice}}
						</view>
						<up-icon name="info-circle" color="#999" :size="14" @click="youhuiDetailShow"></up-icon>
					</view>
					
					<view>
						<text>小计￥</text>
						<text class="font-bold u-font-32">{{allPrice}}</text>
					</view>
				
				</view>
			</view>

			<template v-if="orderInfo.status=='refund'">
				<view class="u-flex u-row-between u-m-t-32">
					<view>退款金额</view>
					<view class="color-999">
						<text class="">{{(orderInfo.refundAmount).toFixed(2)}}</text>
					</view>
				</view>
				<view class="u-flex u-row-between u-m-t-32">
					<view>退款原因</view>
					<view class="color-999">
						<text class="">{{orderInfo.refundRemark||''}}</text>
					</view>
				</view>
				<view class="u-flex u-row-between u-m-t-32 u-p-b-24 border-bottom">
					<view></view>
					<view class="">
						<text class="">退款成功</text>
					</view>
				</view>
			</template>
			<view class="u-flex u-row-between u-m-t-20">
				<view></view>
				<view>
					<text>总计￥</text>
					<text class="font-bold u-font-32">{{to2(allPrice*1+seatFeePrice*1+packFee*1) }}</text>
				</view>
			</view>
			<view class="u-m-t-24">
				<my-button @tap="printOrder" type="cancel" :color="color.ColorMain">重新打印</my-button>
			</view>
		</view>
		<up-popup :round="10" :show="pop.youhui" mode="center" closeOnClickOverlay @close="youhuiDetailHide" >
			<view class="u-p-30" style="width: 80vw;">
				<view class="font-bold  u-text-center">优惠详情</view>
				<view class="u-m-t-32">
					<view class="u-flex u-row-between">
						<view>满减券抵扣</view>
						<view class="color-red">
							<text>￥</text>
							<text>{{orderInfo.fullCouponDiscountAmount}}</text>
						</view>
					</view>
					<view class="u-flex u-row-between u-m-t-18">
						<view>商品券抵扣</view>
						<view class="color-red">
							<text>￥</text>
							<text>{{orderInfo.productCouponDiscountAmount||productCoupPrice}}</text>
						</view>
					</view>
					<view class="u-flex u-row-between u-m-t-18">
						<view>积分抵扣</view>
						<view class="color-red">
							<text>￥</text>
							<text>{{orderInfo.pointsDiscountAmount}}</text>
						</view>
					</view>
					
				</view>
			</view>
		</up-popup>
	</view>
</template>

<script setup>
	import {
		computed, reactive
	} from 'vue';
	import color from '@/commons/color.js'
	import {
		hasPermission
	} from '@/commons/utils/hasPermission.js'
	import {
		isTui,isGift,
		canTuiKuan,
		canTuicai,
		numSum
	} from '@/commons/utils/goodsUtil.js'
	const pop=reactive({
		youhui:false
	})
	function youhuiDetailShow(){
		pop.youhui=true
	}
	function youhuiDetailHide(){
		pop.youhui=false
	}
	const props = defineProps({
		orderInfo: {
			type: Object,
			default: () => {}
		},
		data: {
			type: Array,
			default: () => []
		},
		seatFee: {
			type: Object,
			default: () => {}
		},
		user: {
			type: Object,
			default: () => {
				return {
					id: '',
					isVip: false
				}
			}
		}
	})
	const emits = defineEmits(['tuicai', 'tuikuan', 'printOrder'])

	function returnVipMoney(item) {
		if (!item.memberPrice || !props.user.isVip) {
			return 0
		}
		return (item.memberPrice * item.num).toFixed(2)
	}

	function returnTotalMoney(item) {
		return (item.price * item.num).toFixed(2)
	}

	function to2(n) {
		if (!n) {
			return 0
		}
		return n.toFixed(2)
	}

	function tuicai(item, index) {
		emits('tuicai', item, index)
	}

	function tuikuan(item, index) {
		hasPermission('允许退款').then(res => {
			if (res) {
				emits('tuikuan', item, index)
			}
		})
	}

	function printOrder() {
		emits('printOrder')
	}


	const seatFeePrice = computed(() => {
		if (!props.seatFee.priceAmount) {
			return 0
		}
		const n = props.seatFee.priceAmount * (props.seatFee.status == 'return' ? 0 : 1)
		return n.toFixed(2)
	})
	const goodsOriginAllPrice = computed(() => {
		const goodsPrice = props.data.reduce((prve, cur) => {
			const curTotal = cur.info.reduce((a,
				b) => {
				return a + (b.num * b.price)
			}, 0)
			return prve + curTotal
		}, 0)
		return goodsPrice.toFixed(2)
	})
	
	const freePrice = computed(() => {
		const goodsPrice = props.data.reduce((prve, cur) => {
			const curTotal = cur.info.filter(v => v.gift == true || isTui(v)).reduce((a,
				b) => {
				return a + (b.num * b.price)
			}, 0)
			return prve + curTotal
		}, 0)
		return goodsPrice.toFixed(2)
	})
	const vipDiscountPrice = computed(() => {
		if (!props.user.isVip) {
			return 0
		}
		const goodsPrice = props.data.reduce((prve, cur) => {
			const curTotal = cur.info.filter(v => v.gift != true && v.status !== "return" &&!v.userCouponId&&(v.isMember&&v.memberPrice)&&(v.memberPrice!=v.price)).reduce((a,
				b) => {
				return a + (b.num * (b.price-b.memberPrice))
			}, 0)
			return prve + curTotal
		}, 0)
		return goodsPrice.toFixed(2)
	})
	
	const productCoupPrice=computed(()=>{
		const goodsPrice = props.data.reduce((a, b) => {
			const curTotal = b.info.filter(v => v.gift != true&& v.userCouponId).reduce((prve,
				cur) => {
					const isVip=props.user.isVip&&cur.isMember
					const memberPrice=cur.memberPrice?cur.memberPrice:cur.price
					const price=isVip?memberPrice:cur.price
					const curTotal=price*cur.num
				return prve+curTotal
			}, 0)
			return a + curTotal
		}, 0)
		return goodsPrice.toFixed(2)
	})
	
	const youhuiAllPrice=computed(()=>{
		return (freePrice.value*1+vipDiscountPrice.value*1+props.orderInfo.fullCouponDiscountAmount+props.orderInfo.productCouponDiscountAmount+props.orderInfo.pointsDiscountAmount+productCoupPrice.value*1).toFixed(2)
	})
	const packFee = computed(() => {
		const goodsPrice = props.data.reduce((prve, cur) => {
			const curTotal = cur.info.filter(v => v.gift != true && v.status !== "return").reduce((a,
				b) => {
				return a + b.packAmount
			}, 0)
			return prve + curTotal
		}, 0)
		return goodsPrice.toFixed(2)

	})
	const allPrice = computed(() => {
		return (goodsOriginAllPrice.value-youhuiAllPrice.value).toFixed(2)
	})

	const goodsNumber = computed(() => {
		let result = 0
		result = props.data.reduce((a, b) => {
			const bTotal = b.info.reduce((prve, cur) => {
				return prve + (cur.number || cur.num) * 1;
			}, 0);
			return a + bTotal
		}, 0)
		return result
	})
</script>

<style lang="scss" scoped>
	.img {
		width: 152rpx;
		height: 152rpx;
		border-radius: 6px;
	}

	.border-top {
		border-color: #F6F6F6;
	}

	.border-r-24 {
		border-radius: 24rpx;
	}

	.border-bottom {
		// border-color: rgb(240, 240, 240);
		border-color: #F6F6F6;
	}

	.line-th {
		text-decoration: line-through;
	}

	.tag {
		padding: 4rpx 8rpx 2rpx 10rpx;
		border-radius: 8rpx;
		font-size: 24rpx;

		&.no-pay {
			background-color: rgb(170, 170, 170);
			color: #fff;
		}

		&.refund {
			background-color: #FCE7E7;
			padding: 8rpx 20rpx 6rpx 22rpx;
			color: #EB4F4F;
		}
	}

	.tui {
		background-color: rgb(239, 239, 239);
		border-radius: 4rpx;
		margin-right: 6rpx;
		color: #666;
		padding: 0 4rpx;
		font-size: 20rpx;
	}
</style>